
class PlayerClass{
// ------------------------------------------------------------------- //
	
	LastUsedIP = "0.0.0.0";
	Cash = 0;
	Bank = 0;
	Robskill = 0;
	Copskill = 0;
	Level = 0;
	Wantedlevel = 0;
	Logged = false;
	
	Cuff = false;
	Bomb = false;
	Medic = false;
	Drugs = false;
// ------------------------------------------------------------------- //
	
	constructor( playerName, dbGlobal ){
		local query = ::mysql_query( dbGlobal, "SELECT Cash, Bank, Robskill, Copskill, Wantedlevel, Level, LastUsedIP FROM Accounts WHERE Name='" + playerName + "' AND NameLower='" + playerName.tolower() + "'" );
		if( ::mysql_num_rows( query ) == 1 ){
			local result = ::mysql_fetch_assoc( query );
			Cash = result[ "Cash" ];
			Bank = result[ "Bank" ];
			Robskill = result[ "Robskill" ];
			Copskill = result[ "Copskill" ];
			Wantedlevel = result[ "Wantedlevel" ];
			Level = result[ "Level" ];
			LastUsedIP = result[ "LastUsedIP" ];
		}
		::mysql_free_result( query );
	}
	
	function Join( player ){
		if( Level == 0 ){
			::MessagePlayer( msg.E + "Please register to play.", player );
			::MessagePlayer( msg.E + "Register with /register <password>", player );
		}
		else if( LastUsedIP == player.IP ){
			Logged = true;
			player.Cash = Cash;
			player.WantedLevel = Wantedlevel;
			::MessagePlayer( msg.S + "Welcome back!", player );
		}
		else{
			::MessagePlayer( msg.I + "Please login to play.", player );
			::MessagePlayer( msg.I + "Login with /login <password>", player );
		}
	}
	
	function Update( player, dbGlobal ){
		::mysql_query( dbGlobal, "UPDATE Accounts SET Cash=" + Cash + ", Bank=" + Bank + ", Robskill=" + Robskill + ", Copskill=" + Copskill + ", Wantedlevel=" + Wantedlevel + ", Level=" + Level + ", LastUsedIP='" + LastUsedIP + "' WHERE Name='" + player.Name + "' AND NameLower='" + player.Name.tolower() + "'" );		
	}
	
	function Register( player, password, dbGlobal ){
		::mysql_query( dbGlobal, "INSERT INTO Accounts VALUES('" + player.Name + "', '" + player.Name.tolower() + "', '" + ::SHA256( password ) + "', 0, 0, 0, 0, 0, 1, '" + player.IP + "')" );
		Level = 1;
		LastUsedIP = player.IP;
		Logged = true;
		::MessagePlayer( msg.S + "Successfully registered.", player );
	}
	
	function Login( player, password, dbGlobal ){
		local query = ::mysql_query( dbGlobal, "SELECT Password FROM Accounts WHERE Name='" + player.Name + "' AND NameLower='" + player.Name.tolower() + "'" );
		if( ::mysql_num_rows( query ) == 0 ){
			::MessagePlayer( msg.E + "You are not registered.", player );
		}		
		else{
			local result = ::mysql_fetch_assoc( query );
			if( ::SHA256( password ) != result[ "Password" ] ){
				::MessagePlayer( msg.E + "Wrong password.", player );
			}
			else{
				LastUsedIP = player.IP;
				Logged = true;
				::MessagePlayer( msg.S + "Successfully logged in.", player );
			}
		}
	}
}


function onPlayerJoin( player ){
	local q = mysql_query( sqliteDB, "SELECT UID FROM Bans WHERE NameLower = '"+ player.Name.tolower() +"'" );
	 if( mysql_num_rows( q ) == 1 )
	 {
		 Message( msg.I + " Admin Server " + player.Name + " Reason : banned ");
		 KickPlayer(player); 
	 }
	
	pstats[ player.ID ] = PlayerClass( player.Name, sqliteDB );
	pstats[ player.ID ].Join( player );
	
	playerson.push( player.ID );
	
	//============ HitList ============== //
	if( playerson.len() % 1 == 0){
		local random = random( 0, playerson.len() );
		hitlist.push( random );
	}
	

	MessagePlayer( msg.I + " Select skin to choose a job. \n Jobs available :  Robber, Medic, Cop, Taxi" , player )
}

function onPlayerPart( player, reason ){
	if( pstats[ player.ID ].Level != 0 ){
		pstats[ player.ID ].Update( player, sqliteDB );
	}
	pstats[ player.ID ] = null;
	
	playerson.remove( player.ID );
}

function onPlayerSpawn( player )
{
	local Wantedlevel = pstats[ player.ID ].Wantedlevel;
	
	if ( Wantedlevel < 0) {
	player.Pos = Vector( 392.96, -506.26, 9.39 );
	MessagePlayer( msg.I + "You must clear your Jailtime.", player );
	}
	else if (( Wantedlevel > 0) && ( player.Team == 3))
	{
		player.Health = 0;
		MessagePlayer( msg.E + "Your a wanted player.", player );
	}
	CheckMarker( player );
	player.WantedLevel = pstats[ player.ID ].Wantedlevel;
}


function onPlayerDeath( player, reason )
{
	pstats[ player.ID ].Bomb = false;
	
}

function onTimeChange(oldHour, oldMinute, newHour, newMinute)
{
	if( clock().tointeger() % 10 == 0)
	{
		foreach(i, val in playerson )	{
			local plr = FindPlayer( i );
			if ( plr && pstats[ plr.ID ].Wantedlevel < 0 ) {
				IncWL( plr, 1 );
				Announce( -pstats[ plr.ID ].Wantedlevel * 10 + " seconds" , plr, 2);
				if ( pstats[ plr.ID ].Wantedlevel == 0 ) {
					plr.Pos = Vector( 385.24, -508.02, 9.39 );
					CheckMarker( plr );
					MessagePlayer(msg.I + "You have been released from jail.", plr );
				}
			}
		}
	}
	
}

function CheckMarker( player )
{
    if ( player.Team == 3 ) player.Color = RGB(0, 0, 255);
	else if( pstats[ player.ID ].Wantedlevel > 0 )  player.Color = RGB(255, 0, 0);
	else if ( player.Team == 2 ) player.Color = RGB(0, 255, 0);
	else if ( player.Team == 4 ) player.Color = RGB(255, 0, 255);
	else player.Color = RGB(255, 255, 0);
}


function onKeyDown(player,key)
{
	if( key  == rightclick ){
	if ( player.Team != 3 ) return 0;
	else {
		local plr;
		  foreach(i, val in playerson )	{
	    plr = FindPlayer( i );
		if( !plr && DistanceFromPoint( player.Pos.x, player.Pos.y , plr.Pos.x, plr.Pos.y ) > 3 )return 0;
		else if ( plr.Team == 3) return 0;
		else if ( pstats[ plr.ID ].Wantedlevel <= 0 ) return 0;
		else if( player.Vehicle )MessagePlayer(msg.E + "You must not be in a vehicle to cuff.", player );
		else if( plr.Vehicle )MessagePlayer(msg.E + plr.Name +" is in Vehicle do /drag to drag him out of vehicle.", player );
		else if ( pstats[ plr.ID ].Cuff ) MessagePlayer( msg.E + plr.Name + " is already cuffed.", player);
		else {
			if ( DistanceFromPoint( player.Pos.x, player.Pos.y , plr.Pos.x, plr.Pos.y ) < 3 ) {
				pstats[ plr.ID ].Cuff = true;
				plr.IsFrozen = true;
				Message( msg.S + player.Name +" has cuffed "+ plr.Name );
				break;
				}
			else MessagePlayer( msg.I + player.Name +" is far away.", player );
			}
		  }
		}
	}
}

function onPickupPickedUp( player, pickup )
{
	//Robbing
	if ( pickup.Model == 408 ) {
		if( player.Team == 3) return 0;
		pstats[ player.ID ].Robskill++;
		IncWL( player, 1);
		local robbedcash = random( 100, 2000);
		IncCash( player, robbedcash );
		Message( msg.I + player.Name +" has robbed " + robbedcash + "$ at "+ GetDistrictName( player.Pos.x, player.Pos.y ) );
		pickup.RespawnTime = 60000;
	}
	
	// Surrender
	else if ( pickup.Model == 375 ) {
		if( player.Team == 3) return 0;
		else if ( pstats[ player.ID ].Wantedlevel == 0) MessagePlayer( msg.I + "Your not wanted.", player);
		else {
			DecWL( player, pstats[ player.ID ].Wantedlevel * 2 );
			player.Pos = Vector( 392.96, -506.26, 9.39 );
			Message( msg.I + player.Name + " has surrendered.");
		}
	}

	// Bug at respawn time
	else if ( pickup.Model == 380 ) {
		if( player.Team == 3) return 0;
		else if( pstats[ player.ID ].Bomb == false ) MessagePlayer( msg.E + " You need bomb to rob bank.", player);
		else {
			pstats[ player.ID ].Bomb = false;
			pickup.RespawnTime = 100000;
			local random = random(20000, 100000);
			IncCash( player, random );
			Message( msg.I + player.Name + " has robbed bank. Stolen : " + random );
		}
	}
	
	else if ( pickup.Model == 582 ) {
		if( player.Team == 3) return 0;
		else if( pstats[ player.ID ].Bomb ) MessagePlayer( msg.E + " You already purchased bomb.", player);
		else if( player.Cash < 10000 ) MessagePlayer( msg.E + " You dont have enough cash.", player);
		else {
			DecCash( player, 10000 );
			pstats[ player.ID ].Bomb = true;
			MessagePlayer( msg.S +" You have purchased bomb.", player);
		}
	}
	
}

function createpickups(){
	
CreatePickup(408, Vector( 207.214, -470.93, 11.0699 ));  // bunchoftools
CreatePickup(408, Vector( 467.072, -53.9059, 11.4837 ));  // malibu
CreatePickup(408, Vector( 418.765, 91.317, 11.2808 ));  // pizzavc
CreatePickup(408, Vector( 491.143, 701.207, 12.1033 ));  // hospitalvc
CreatePickup(408, Vector( 450.729, 782.371, 12.954 ));  // storevc
CreatePickup(408, Vector( 472.171, 1009.33, 19.1462 ));  // tarbrush1
CreatePickup(408, Vector( 471.983, 1014.02, 20.0473 ));  // tarbrush2
CreatePickup(408, Vector( 421.842, 1026.69, 25.2993 ));  // gash
CreatePickup(408, Vector( 364.444, 1052.46, 19.213 ));  // ammunationmall
CreatePickup(408, Vector( 363.719, 1074.71, 19.0613 ));  // tooledup
CreatePickup(408, Vector( 351.45, 1111.41, 25.3879 ));  // musicshop
CreatePickup(408, Vector( 469.438, 1206.76, 19.0103 ));  // jewelry
CreatePickup(408, Vector( 2.39992, 956.954, 11.1667 ));  // film
CreatePickup(408, Vector( -680.664, 1204.1, 11.1093 ));  // ammudowntown
CreatePickup(408, Vector( -822.855, 1138.59, 12.4111 ));  // hospitaldt
CreatePickup(408, Vector( -853.756, 850.456, 11.3846 ));  // jewelrydt
CreatePickup(408, Vector( -905.961, 799.732, 11.4661 ));  // pizzadt
CreatePickup(408, Vector( -830.144, 742.221, 11.2885 ));  // medicaldt
CreatePickup(408, Vector( -594.15, 643.695, 11.6765 ));  // bikers
CreatePickup(408, Vector( -846.475, -71.8574, 11.5403 ));  // medicallh
CreatePickup(408, Vector( -1079.9, -275.156, 12.0882 ));  // printworks
CreatePickup(408, Vector( -1038.02, 80.8385, 11.6263 ));  // pizzalh
CreatePickup(408, Vector( -997.021, 186.33, 12.434 ));  // kaufman
CreatePickup(408, Vector( -887.722, -474.079, 13.1115 ));  // hospitallh
CreatePickup(408, Vector( -881.679, -575.985, 15.0586 ));  // cherrypopper
CreatePickup(408, Vector( -855.472, -631.404, 11.3756 ));  // donuts
CreatePickup(408, Vector( -1166.79, -620.55, 11.8279 ));  // cubaan
CreatePickup(408, Vector( -1031.45, -850.113, 13.5224 ));  // sunshine
CreatePickup(408, Vector( -665.544, -1484.63, 13.8016 ));  // boatyard
CreatePickup(408, Vector( -112.599, -975.639, 10.4634 ));  // hospitalvc
CreatePickup(408, Vector( -63.8908, -1485.23, 10.505 ));  // ammuvc
CreatePickup(408, Vector( 90.5438, -1454.35, 10.5655 ));  //  poleposition


//Bank Rob
CreatePickup(380, Vector( -939.309, -351.41, 17.8038 ));  // Bank Rob
CreatePickup(582, Vector( -671.93, 1206.86, 11.1082 ));  // Bomb

CreatePickup(375, Vector( 389.07, -476.498, 12.3432 ));       // Surrender

//Nitro
//CreatePickup(408, Vector( 60.694, -1072.84, 10.4633 ));  // nitro1
//CreatePickup(408, Vector( 40.3707, -1055.39, 10.4633 ));  // nitro2


//MISC





//Markers
CreateMarker( 1, Vector(  -1012.07, -865.003, 13.0807 ), 5, RGB(10, 10, 10), 26 ); // Sunshine
CreateMarker( 1, Vector( -908.112, -340.912, 13.3802 ), 5, RGB(10, 10, 10), 24 ); // Bank

}



function IncCash( player, amount )
{
	local cash = pstats[ player.ID ].Cash;
	local add = cash + amount;
          pstats[ player.ID ].Cash = add;
          player.Cash = add;
}

function DecCash( player, amount )
{
    local cash = pstats[ player.ID ].Cash;
    local det = cash - amount;
        pstats[ player.ID ].Cash = det;
        player.Cash = det;
}

function DecBank( player, amount )
{
    local bank = pstats[ player.ID ].Bank;
        local det = bank - amount;
        pstats[ player.ID ].Bank = det;
}
function IncBank( player, amount )
{
      local bank = pstats[ player.ID ].Bank;
          local add = bank + amount;
          pstats[ player.ID ].Bank = add;
}

function IncWL( player, amount )
{
	local wl = pstats[ player.ID ].Wantedlevel;
	local add = wl + amount;
          pstats[ player.ID ].Wantedlevel = add;
          player.WantedLevel = add;
		  CheckMarker( player );
}

function DecWL( player, amount )
{
    local wl = pstats[ player.ID ].Wantedlevel;
    local det = wl - amount;
        pstats[ player.ID ].Wantedlevel = det;
        player.WantedLevel = det;
		CheckMarker( player );
}

function random(start, finish)
{
	local t = ((rand() % (finish - start)) + start);
	return t;
}

function GetPlayer( plr )
{
    if ( plr ) 
    {
        if ( IsNum( plr ) ) 
        {
            plr = FindPlayer( plr.tointeger() );
            if ( plr ) return plr;
            else return null;
        }
	    else 
        {      
            plr = FindPlayer( plr ); 
            if ( plr ) return plr;
            else return null;
        }
    }
    else return null;
}





//Vehicle Functions

function Cars()
{
	for( local i = 1; i < GetVehicleCount() ; i++ )
	{
	   local veh = FindVehicle( i );
	   local model = CarModel(veh);
	
	   if ( model == 3 )
	   {
	   mysql_query( sqliteDB, "REPLACE INTO Cars ( ID, Cost, Owner, Shared ) VALUES ( '" + veh.ID + "', 'Not Forsale', 'Government', 'None' )" );
	   }
	   else{
	   mysql_query( sqliteDB, "REPLACE INTO Cars ( ID, Cost, Owner, Shared ) VALUES ( '" + veh.ID + "', '500000', 'Sunshine-Autos', 'None' )" );
	   } 
	}
}

function CarModel(veh)
{

	switch( veh.Model ) {

   case 155: case 156: case 157: case 162: case 163: case 183: case 200: case 218: case 220: case 227: case 236:
		return 3;
		break;
   default : 
		return 1;
	}
	
}


function onPlayerEnterVehicle( player, vehicle, door )
{
	local q = mysql_query( sqliteDB, "SELECT * FROM Cars WHERE ID='" + vehicle.ID + "'" );
	local result = mysql_fetch_assoc( q );
		
	if ( result ) {
		MessagePlayer( msg.I + " You have entered ID: " + vehicle.ID + "  Cost: " + result["Cost"] + "  Owner : " + result["Owner"] + "  Shared : " + result["Shared"] , player );
	}
	
	if( ( CarModel(vehicle) == 3 ) && ( player.Team != 3 )  ) 
	{
		MessagePlayer( msg.E + "You can't enter cop's vehicle.", player);
		player.Pos = player.Pos;
	}
}